Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 136593)
+++ channels/chan_skinny.c	(working copy)
@@ -1236,6 +1236,7 @@
 	int lastcallreference;
 	int capability;
 	int earlyrtp;
+	int lampstatus;
 	struct sockaddr_in addr;
 	struct in_addr ourip;
 	AST_LIST_HEAD(, skinny_line) lines;
@@ -1991,6 +1992,7 @@
 	req->data.setlamp.stimulus = htolel(stimulus);
 	req->data.setlamp.stimulusInstance = htolel(instance);
 	req->data.setlamp.deviceStimulus = htolel(indication);
+	d->lampstatus = indication;
 	transmit_response(d, req);
 }
 
@@ -2286,7 +2288,9 @@
 		}
 	}
 
-	transmit_lamp_indication(d, STIMULUS_LINE, sd->instance, lamp);
+	if (d->lampstatus != lamp) {
+		transmit_lamp_indication(d, STIMULUS_LINE, sd->instance, lamp);
+	}
 	transmit_callstate(d, sd->instance, callstate, 0);
 	sd->laststate = state;
 
@@ -2350,10 +2354,15 @@
 		}
 	}
 	/* If at least one line has VM, turn the device level lamp on */
-	if (device_lamp)
-		transmit_lamp_indication(d, STIMULUS_VOICEMAIL, 0, SKINNY_LAMP_ON);
-	else
-		transmit_lamp_indication(d, STIMULUS_VOICEMAIL, 0, SKINNY_LAMP_OFF);
+	if (device_lamp) {
+		if (d->lampstatus != SKINNY_LAMP_ON) {
+			transmit_lamp_indication(d, STIMULUS_VOICEMAIL, 0, SKINNY_LAMP_ON);
+		}
+	} else {
+		if (d->lampstatus != SKINNY_LAMP_OFF) {
+			transmit_lamp_indication(d, STIMULUS_VOICEMAIL, 0, SKINNY_LAMP_OFF);
+		}
+	}
 }
 
 /* I do not believe skinny can deal with video.
